#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int     is_member;
    int    *last;
    int    *location;
    int    *middle;
    struct pair<int *, int *>  pair(0, 0);
    int     test_sequence[20];

    middle = test_sequence + 10;
    last = test_sequence + 20;

    ostream_iterator<int> out_stream(cout, " ");
    less<int> less_than;

    generate(test_sequence, middle, IotaGen<int>(0));
    generate(middle, last, IotaGen<int>(9));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 9 10 11 12 13 14 15 16 17 18

    location = lower_bound(test_sequence, last, 9);
    copy(location, last, out_stream), cout << endl;
    // Output: 9 9 10 11 12 13 14 15 16 17 18

    location = lower_bound(test_sequence, last, 30);
    copy(location, last, out_stream), cout << endl;
    // Output:

    location = lower_bound(test_sequence, last, 9, less_than);
    copy(location, last, out_stream), cout << endl;
    // Output: 9 9 10 11 12 13 14 15 16 17 18


    location = upper_bound(test_sequence, last, 9);
    copy(location, last, out_stream), cout << endl;
    // Output: 10 11 12 13 14 15 16 17 18

    location = upper_bound(test_sequence, last, 30);
    copy(location, last, out_stream), cout << endl;
    // Output:

    location = upper_bound(test_sequence, last, 9, less_than);
    copy(location, last, out_stream), cout << endl;
    // Output: 10 11 12 13 14 15 16 17 18


    pair = equal_range(test_sequence, last, 9);
    copy(pair.first, pair.second, out_stream), cout << endl;
    // Output: 9 9

    pair = equal_range(test_sequence, last, 30);
    copy(pair.first, pair.second, out_stream), cout << endl;
    // Output:

    pair = equal_range(test_sequence, last, 9, less_than);
    copy(pair.first, pair.second, out_stream), cout << endl;
    // Output: 9 9


    is_member = binary_search(test_sequence, last, 10);
    cout << (is_member ? "True" : "False") << endl;
    // Output: True

    is_member = binary_search(test_sequence, last, 20);
    cout << (is_member ? "True" : "False") << endl;
    // Output: False

    is_member = binary_search(test_sequence, last, 15, less_than);
    cout << (is_member ? "True" : "False") << endl;
    // Output: True
}
