#include "algo.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int    *last3;
    int    *new_first;
    int    *new_last2;
    int     test_sequence1[15];
    int     test_sequence2[20];
    int    *test_sequence3;

    last1 = test_sequence1 + 15;
    last2 = test_sequence2 + 20;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence1, last1, IotaGen<int>(0));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    generate(test_sequence2, last2, IotaGen<int>(20));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39

    new_last2 = copy(test_sequence1, last1, test_sequence2);
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 35 36 37 38 39
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    test_sequence3 = test_sequence2 + 5;
    last3 = last2;

    new_last2 = copy(test_sequence3, last3, test_sequence2);
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 5 6 7 8 9 10 11 12 13 14 35 36 37 38 39 35 36 37 38 39
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 5 6 7 8 9 10 11 12 13 14 35 36 37 38 39


    last3 = test_sequence3 + 10;

    new_first = copy_backward(test_sequence2, last3, last2);
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 5 6 7 8 9 5 6 7 8 9 10 11 12 13 14 35 36 37 38 39
    copy(new_first, last2, out_stream), cout << endl;
    // Output: 5 6 7 8 9 10 11 12 13 14 35 36 37 38 39
}
