#include "algo.h"
#include "heap.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last;
    int    *last_minus_one;
    int     test_sequence[15];

    last_minus_one = test_sequence + 14;
    last = last_minus_one + 1;

    ostream_iterator<int> out_stream(cout, " ");
    greater<int> greater_than;

    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14
	
    make_heap(test_sequence, last_minus_one);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 13 10 12 8 9 11 6 7 3 1 4 0 5 2 14

    push_heap(test_sequence, last);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 14 10 13 8 9 11 12 7 3 1 4 0 5 2 6

    pop_heap(test_sequence, last);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 13 10 12 8 9 11 6 7 3 1 4 0 5 2 14

    sort_heap(test_sequence, last_minus_one);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14


    make_heap(test_sequence, last_minus_one, greater_than);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    push_heap(test_sequence, last, greater_than);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    pop_heap(test_sequence, last, greater_than);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 1 3 2 7 4 5 6 14 8 9 10 11 12 13 0

    sort_heap(test_sequence, last_minus_one, greater_than);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 14 13 12 11 10 9 8 7 6 5 4 3 2 1 0
}
