#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int     is_less;
    int    *last1;
    int    *last2;
    int    *middle;
    int     test_sequence1[20];
    int     test_sequence2[25];

    middle = test_sequence1 + 10;
    last1 = test_sequence1 + 20;
    last2 = test_sequence2 + 25;

    ostream_iterator<int> out_stream(cout, " ");
    less<int> less_than;

    generate(test_sequence1, middle, IotaGen<int>(0));
    generate(middle, last1, IotaGen<int>(9));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 9 10 11 12 13 14 15 16 17 18

    generate(test_sequence2, last2, IotaGen<int>(0));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24

    is_less = lexicographical_compare(test_sequence1, last1, test_sequence2,
                                      last2);
    cout << (is_less ? "True" : "False") << endl;
    // Output: True

    is_less = lexicographical_compare(test_sequence2, last2, test_sequence1,
                                      last1);
    cout << (is_less ? "True" : "False") << endl;
    // Output: False

    is_less = lexicographical_compare(test_sequence1, last1, test_sequence1,
                                      last1);
    cout << (is_less ? "True" : "False") << endl;
    // Output: False


    generate(test_sequence1, last1, IotaGen<int>(0));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19


    is_less = lexicographical_compare(test_sequence1, last1, test_sequence2,
                                      last2);
    cout << (is_less ? "True" : "False") << endl;
    // Output: True

    is_less = lexicographical_compare(test_sequence2, last2, test_sequence1,
                                      last1);
    cout << (is_less ? "True" : "False") << endl;
    // Output: False

    is_less = lexicographical_compare(test_sequence1, last1, test_sequence2,
                                      last2, less_than);
    cout << (is_less ? "True" : "False") << endl;
    // Output: True

    is_less = lexicographical_compare(test_sequence2, last2, test_sequence1,
                                      last1, less_than);
    cout << (is_less ? "True" : "False") << endl;
    // Output: False
}
