#include "defalloc.h"
#include "algo.h"
#include "tempbuf.cpp"   // Can also just compile and link wiht this file
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int    *last3;
    int    *middle1;
    int    *middle2;
    int    *middle3;
    int    *new_last3;
    int     test_sequence1[8];
    int     test_sequence2[12];
    int     test_sequence3[20];

    middle1 = test_sequence1 + 4;
    last1 = test_sequence1 + 8;
    middle2 = test_sequence2 + 5;
    last2 = test_sequence2 + 10;
    last3 = test_sequence3 + 20;

    ostream_iterator<int> out_stream(cout, " ");
    less<int> less_than;

    generate(test_sequence1, middle1, IotaGen<int>(0));
    generate(middle1, last1, IotaGen<int>(10));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 10 11 12 13

    generate(test_sequence2, middle2, IotaGen<int>(-3));
    generate(middle2, last2, IotaGen<int>(6));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: -3 -2 -1 0 1 6 7 8 9 10

    generate(test_sequence3, last3, IotaGen<int>(20));
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39

    new_last3 = merge(test_sequence1, last1, test_sequence2, last2,
                      test_sequence3);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: -3 -2 -1 0 0 1 1 2 3 6 7 8 9 10 10 11 12 13 38 39
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: -3 -2 -1 0 0 1 1 2 3 6 7 8 9 10 10 11 12 13

    generate(test_sequence3, last3, IotaGen<int>(20));
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39

    new_last3 = merge(test_sequence1, last1, test_sequence2, last2,
                      test_sequence3, less_than);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: -3 -2 -1 0 0 1 1 2 3 6 7 8 9 10 10 11 12 13 38 39
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: -3 -2 -1 0 0 1 1 2 3 6 7 8 9 10 10 11 12 13


    middle3 = copy(test_sequence1, last1, test_sequence3);
    new_last3 = copy(test_sequence2, last2, middle3);
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output:  0 1 2 3 10 11 12 13 -3 -2 -1 0 1 6 7 8 9 10

    inplace_merge(test_sequence3, middle3, new_last3);
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: -3 -2 -1 0 0 1 1 2 3 6 7 8 9 10 10 11 12 13

    middle3 = copy(test_sequence1, last1, test_sequence3);
    new_last3 = copy(test_sequence2, last2, middle3);
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output:  0 1 2 3 10 11 12 13 -3 -2 -1 0 1 6 7 8 9 10

    inplace_merge(test_sequence3, middle3, new_last3, less_than);
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: -3 -2 -1 0 0 1 1 2 3 6 7 8 9 10 10 11 12 13
}
