#include "algo.h"
#include "function.h"
#include "iota.h"
#include "random.cpp"   // Can also just compile and link with this file

void
main(int argc, char *argv[])

{
    int    *last;
    int    *n;
    int     test_sequence[15];

    n = test_sequence + 9;
    last = test_sequence + 15;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    random_shuffle(test_sequence, last);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: (the sequence of 0 through 14 with elements in random order)

    nth_element(test_sequence, n, last);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: ? ? ? ? ? ? ? ? ? ? 10 1? 1? 1? 1?

    random_shuffle(test_sequence, last);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: (the sequence of 0 through 14 with elements in random order)

    nth_element(test_sequence, n, last, less<int>());
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: ? ? ? ? ? ? ? ? ? ? 10 1? 1? 1? 1?
}
