#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int    *new_last1;
    int    *new_last2;
    int     test_sequence1[15];
    int     test_sequence2[20];

    last1 = test_sequence1 + 15;
    last2 = test_sequence2 + 20;

    ostream_iterator<int> out_stream(cout, "");

    generate(test_sequence1, last1, IotaGen<int>(0));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    generate(test_sequence2, last2, IotaGen<int>(0));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    new_last2 = partial_sum(test_sequence1, last1, test_sequence2);
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 3 6 10 15 21 28 36 45 55 66 78 91 105 15 16 17 18 19
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 0 1 3 6 10 15 21 28 36 45 55 66 78 91 105


    generate(test_sequence2, last2, IotaGen<int>(0));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    new_last2 = partial_sum(test_sequence1, last1, test_sequence2, plus<int>());
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 3 6 10 15 21 28 36 45 55 66 78 91 105 15 16 17 18 19
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 0 1 3 6 10 15 21 28 36 45 55 66 78 91 105


    new_last1 = partial_sum(test_sequence1, last1, test_sequence1);
    copy(test_sequence1, new_last1, out_stream), cout << endl;
    // Output: 0 1 3 6 10 15 21 28 36 45 55 66 78 91 105
}
