#include "defalloc.h"
#include "algo.h"
#include "tempbuf.cpp"   // Can also compile and link with this file
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last;
    int    *middle;
    int    *new_middle;
    int     test_sequence[15];

    middle = test_sequence + 5;
    last = test_sequence + 15;

    ostream_iterator<int> out_stream(cout, " ");
    binder2nd< less<int> > less_than_8(less<int>(), 8);

    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    rotate(test_sequence, middle, last);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 5 6 7 8 9 10 11 12 13 14 0 1 2 3 4

    new_middle = partition(test_sequence, last, less_than_8);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 5 6 7 4 3 2 1 0 13 14 12 11 10 9 8 
    copy(test_sequence, new_middle, out_stream), cout << endl;
    // Output: 5 6 7 4 3 2 1 0 
    copy(new_middle, last, out_stream), cout << endl;
    // Output: 13 14 12 11 10 9 8


    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    rotate(test_sequence, middle, last);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 5 6 7 8 9 10 11 12 13 14 0 1 2 3 4 

    new_middle = stable_partition(test_sequence, last, less_than_8);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 5 6 7 0 1 2 3 4 8 9 10 11 12 13 14 
    copy(test_sequence, new_middle, out_stream), cout << endl;
    // Output: 5 6 7 0 1 2 3 4 
    copy(new_middle, last, out_stream), cout << endl;
    // Output: 8 9 10 11 12 13 14 
}
