#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last;
    int     perm_exists;
    int     test_sequence[15];

    last = test_sequence + 15;

    ostream_iterator<int> out_stream(cout, " ");
    less<int> less_than;

    generate(test_sequence, last, IotaGen<int>(0));
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    perm_exists = prev_permutation(test_sequence, last);
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 14 13 12 11 10 9 8 7 6 5 4 3 2 1 0
    cout << ((perm_exists) ? "True" : "False") << endl;
    // Output: False

    perm_exists = next_permutation(test_sequence, last);   
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14
    cout << ((perm_exists) ? "True" : "False") << endl;
    // Output: False

    perm_exists = next_permutation(test_sequence, last, less_than);   
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 14 13
    cout << ((perm_exists) ? "True" : "False") << endl;
    // Output: True

    perm_exists = prev_permutation(test_sequence, last, less_than);   
    copy(test_sequence, last, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14
    cout << ((perm_exists) ? "True" : "False") << endl;
    // Output: True
}
