#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int    *new_last1;
    int     test_sequence1[20];
    int     test_sequence2[15];

    last1 = test_sequence1 + 20;
    last2 = test_sequence2 + 15;

    ostream_iterator<int> out_stream(cout, " ");

    generate(test_sequence1, last1, IotaGen<int>(0));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    new_last1 = remove(test_sequence1, last1, 10);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 11 12 13 14 15 16 17 18 19 19
    copy(test_sequence1, new_last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 11 12 13 14 15 16 17 18 19


    new_last1 = remove_if(test_sequence1, last1, bind2nd(less<int>(), 9));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 9 11 12 13 14 15 16 17 18 19 19 12 13 14 15 16 17 18 19 19
    copy(test_sequence1, new_last1, out_stream), cout << endl;
    // Output: 9 11 12 13 14 15 16 17 18 19 19


    generate(test_sequence2, last2, IotaGen<int>(20));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34

    new_last1 = remove_copy(test_sequence2, last2, test_sequence1, 30);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 31 32 33 34 15 16 17 18 19 19
    copy(test_sequence1, new_last1, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 31 32 33 34


    new_last1 = remove_copy_if(test_sequence2, last2, test_sequence1,
                               bind2nd(less<int>(), 29));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 29 30 31 32 33 34 26 27 28 29 31 32 33 34 15 16 17 18 19 19
    copy(test_sequence1, new_last1, out_stream), cout << endl;
    // Output: 29 30 31 32 33 34
}
