#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int    *last3;
    int    *middle1;
    int    *new_last3;
    int     result;
    int     test_sequence1[6];
    int     test_sequence2[7];
    int     test_sequence3[15];

    middle1 = test_sequence1 + 3;
    last1 = test_sequence1 + 6;
    last2 = test_sequence2 + 7;
    last3 = test_sequence3 + 15;

    ostream_iterator<int> out_stream(cout, " ");
    less<int> less_than;

    generate(test_sequence1, middle1, IotaGen<int>(0));
    generate(middle1, last1, IotaGen<int>(4));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 4 5 6

    generate(test_sequence2, last2, IotaGen<int>(0));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6

    result = includes(test_sequence1, last1, test_sequence2, last2);
    cout << (result ? "True" : "False") << endl;
    // Output: False

    result = includes(test_sequence2, last2, test_sequence1, last1);
    cout << (result ? "True" : "False") << endl;
    // Output: True

    result = includes(test_sequence2, last2, test_sequence1, last1, less_than);
    cout << (result ? "True" : "False") << endl;
    // Output: True


    generate(test_sequence2, last2, IotaGen<int>(2));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 2 3 4 5 6 7 8

    generate(test_sequence3, last3, IotaGen<int>(15));
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29

    new_last3 = set_union(test_sequence1, last1, test_sequence2, last2,
                          test_sequence3);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 24 25 26 27 28 29
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8

    generate(test_sequence3, last3, IotaGen<int>(20));
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34

    new_last3 = set_union(test_sequence2, last2, test_sequence1, last1,
                          test_sequence3, less_than);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 29 30 31 32 33 34
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8


    generate(test_sequence2, last2, IotaGen<int>(1));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 1 2 3 4 5 6 7

    new_last3 = set_intersection(test_sequence1, last1, test_sequence2, last2,
                                 test_sequence3);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 1 2 4 5 6 5 6 7 8 29 30 31 32 33 34
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: 1 2 4 5 6

    generate(test_sequence3, last3, IotaGen<int>(20));
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34

    new_last3 = set_intersection(test_sequence2, last2, test_sequence1, last1,
                                 test_sequence3, less_than);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 1 2 4 5 6 25 26 27 28 29 30 31 32 33 34
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: 1 2 4 5 6


    new_last3 = set_difference(test_sequence1, last1, test_sequence2, last2,
                               test_sequence3);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 0 2 4 5 6 25 26 27 28 29 30 31 32 33 34
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: 0

    generate(test_sequence3, last3, IotaGen<int>(20));
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34

    new_last3 = set_difference(test_sequence2, last2, test_sequence1, last1,
                               test_sequence3, less_than);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 3 7 22 23 24 25 26 27 28 29 30 31 32 33 34
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: 3 7


    new_last3 = set_symmetric_difference(test_sequence1, last1, test_sequence2,
                                         last2, test_sequence3);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 0 3 7 23 24 25 26 27 28 29 30 31 32 33 34
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: 0 3 7

    generate(test_sequence3, last3, IotaGen<int>(20));
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34

    new_last3 = set_symmetric_difference(test_sequence1, last1, test_sequence2,
                                         last2, test_sequence3, less_than);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 0 3 7 23 24 25 26 27 28 29 30 31 32 33 34
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // Output: 0 3 7
}
