#include "defalloc.h"
#include "algo.h"
#include "tempbuf.cpp"  // Can also just compile and link with this file
#include "heap.h"
#include "function.h"
#include "iota.h"
#include "random.cpp"   // Can also just compile and link with this file

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int    *middle;
    int    *new_last2;
    int     test_sequence1[15];
    int     test_sequence2[10];

    middle = test_sequence1 + 10;
    last1 = test_sequence1 + 15;
    last2 = test_sequence2 + 10;

    ostream_iterator<int> out_stream(cout, " ");
    less<int> less_than;

    generate(test_sequence1, last1, IotaGen<int>(0));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    random_shuffle(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: (the sequence of 0 through 14 with elements in random order)

    sort(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    random_shuffle(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: (the sequence of 0 through 14 with elements in random order)

    sort(test_sequence1, last1, less_than);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14


    random_shuffle(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: (the sequence of 0 through 14 with elements in random order)

    stable_sort(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    random_shuffle(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: (the sequence of 0 through 14 with elements in random order)

    stable_sort(test_sequence1, last1, less_than);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14


    random_shuffle(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: (the sequence of 0 through 14 with elements in random order)

    partial_sort(test_sequence1, middle, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 1? 1? 1? 1? 1?

    random_shuffle(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: (the sequence of 0 through 14 with elements in random order)

    partial_sort(test_sequence1, middle, last1, less_than);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 1? 1? 1? 1? 1?


    generate(test_sequence2, last2, IotaGen<int>(0));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29

    random_shuffle(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: (the sequence of 0 through 14 with elements in random order)

    new_last2 = partial_sort_copy(test_sequence1, last1, test_sequence2, last2);
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9

    generate(test_sequence2, last2, IotaGen<int>(0));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29

    new_last2 = partial_sort_copy(test_sequence1, last1, test_sequence2, last2,
                                  less_than);
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9
}
