#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int    *last3;
    int    *new_last1;
    int    *new_last2;
    int    *new_last3;
    int     test_sequence1[15];
    int     test_sequence2[17];
    int     test_sequence3[20];

    last1 = test_sequence1 + 15;
    last2 = test_sequence2 + 17;
    last3 = test_sequence3 + 20;

    ostream_iterator<int> out_stream(cout, " ");
    binder2nd< times<int> > times_two(times<int>(), 2);
    times<int> product;

    generate(test_sequence1, last1, IotaGen<int>(0));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    generate(test_sequence2, last2, IotaGen<int>(0));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16

    new_last2 = transform(test_sequence1, last1, test_sequence2, times_two);
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 2 4 6 8 10 12 14 16 18 20 22 24 26 28 15 16
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 0 2 4 6 8 10 12 14 16 18 20 22 24 26 28

    new_last1 = transform(test_sequence1, last1, test_sequence1, times_two);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 2 4 6 8 10 12 14 16 18 20 22 24 26 28
    copy(test_sequence1, new_last1, out_stream), cout << endl;
    // Output: 0 2 4 6 8 10 12 14 16 18 20 22 24 26 28


    generate(test_sequence1, last1, IotaGen<int>(0));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14

    generate(test_sequence2, last2, IotaGen<int>(-1));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: -1 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15

    generate(test_sequence3, last3, IotaGen<int>(0));
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19

    new_last3 = transform(test_sequence1, last1, test_sequence2,
                          test_sequence3, product);
    copy(test_sequence3, last3, out_stream), cout << endl;
    // Output: 0 0 2 6 12 20 30 42 56 72 90 110 132 156 182 15 16 17 18 19
    copy(test_sequence3, new_last3, out_stream), cout << endl;
    // 0 0 2 6 12 20 30 42 56 72 90 110 132 156 182

    new_last1 = transform(test_sequence1, last1, test_sequence2,
                          test_sequence1, product);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 0 2 6 12 20 30 42 56 72 90 110 132 156 182
    copy(test_sequence1, new_last1, out_stream), cout << endl;
    // Output: 0 0 2 6 12 20 30 42 56 72 90 110 132 156 182
}
