#include "algo.h"
#include "function.h"
#include "iota.h"

void
main(int argc, char *argv[])

{
    int    *last1;
    int    *last2;
    int    *middle1;
    int    *middle2;
    int    *new_last1;
    int    *new_last2;
    int     test_sequence1[20];
    int     test_sequence2[20];

    middle1 = test_sequence1 + 7;
    middle2 = test_sequence1 + 14;
    last1 = test_sequence1 + 20;
    last2 = test_sequence2 + 20;

    ostream_iterator<int> out_stream(cout, " ");
    equal_to<int> equals;

    generate(test_sequence1, middle1, IotaGen<int>(0));
    generate(middle1, middle2, IotaGen<int>(6));
    generate(middle2, last1, IotaGen<int>(12));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 6 7 8 9 10 11 12 12 13 14 15 16 17

    new_last1 = unique(test_sequence1, last1);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 16 17
    copy(test_sequence1, new_last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17


    generate(test_sequence1, middle1, IotaGen<int>(0));
    generate(middle1, middle2, IotaGen<int>(6));
    generate(middle2, last1, IotaGen<int>(12));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 6 7 8 9 10 11 12 12 13 14 15 16 17

    new_last1 = unique(test_sequence1, last1, equals);
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 16 17
    copy(test_sequence1, new_last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17


    generate(test_sequence1, middle1, IotaGen<int>(0));
    generate(middle1, middle2, IotaGen<int>(6));
    generate(middle2, last1, IotaGen<int>(12));
    copy(test_sequence1, last1, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 6 7 8 9 10 11 12 12 13 14 15 16 17

    generate(test_sequence2, last2, IotaGen<int>(20));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39

    new_last2 = unique_copy(test_sequence1, last1, test_sequence2);
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 38 39
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17


    generate(test_sequence2, last2, IotaGen<int>(40));
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59

    new_last2 = unique_copy(test_sequence1, last1, test_sequence2, equals);
    copy(test_sequence2, last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 58 59
    copy(test_sequence2, new_last2, out_stream), cout << endl;
    // Output: 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17
}
